#<profile4xi profile = "02" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "state4xi.py">
#<abstract4xi abstract = "provides State4Xi class"/>
#<refer4xi reference = "managers.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'State4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
      
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import SyncManager
except:
    print("state4xi.py *** failed in multiprocessing.managers import SyncManager ***")
try:                             
    from multiprocessing.managers import State
except:
    print("state4xi.py *** failed in from multiprocessing.managers import State ***")  
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi   
#"
#/>



#
# =================================================================================================
#<class4xi class = "State4Xi" base = "object" child = "None" 
#  synopsis = "represent state of a manager"
#  usage = "
#     managers.py 
#         BaseManager:
#             __init__:                              
#                 self._state = State()
#                 self._state.value = State.INITIAL
#
#     origininal class State has only the following lines and not even __init__
#         State.__slots__ = ['value']
#         State.INITIAL = 0
#         State.STARTED = 1
#         State.SHUTDOWN = 2
#
#     basemanager4xi.py:
#         BaseManager4Xi:
#             __init__:                              
#                 self._state = State4Xi()
#                 self._state.value = State4Xi.INITIAL
#     syncmanager4xi.py:
#         SyncManager4Xi
#             __init__: 
#                 self._state = State4Xi()
#                 self._state.value = State4Xi.INITIAL
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class State4Xi(object):
    '''
    presents state of a manager
    '''

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    __slots__ = ['value']
    INITIAL = 0
    STARTED = 1
    SHUTDOWN = 2    
    #"
    #/>
        

#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_state4xi.txt
#   sense-test-state4xi.xml
#   reason-test-state4xi.xml
#   ace-test-state4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of state4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

